<template>
  <span>
    <template v-if="components.length">
      <component
        :is="entry.component"
        v-for="(entry, i) in components"
        :key="`page-content__${entry.component}-${i}`"
        :layout="entry"
      ></component>
    </template>
    <template v-else>
      <div v-html="content"></div>
    </template>
  </span>
</template>

<script>
// import { upperFirst } from 'lodash'

const components = {
  vButton: () => import('~/components/content/Button' /* webpackChunkName: "components/content/Button" */),
  vCard: () => import('~/components/content/Card' /* webpackChunkName: "components/content/Card" */),
  vCollectionPage: () =>
    import('~/components/content/CollectionPage' /* webpackChunkName: "components/content/CollectionPage" */),
  vContactUs: () => import('~/components/content/ContactUs' /* webpackChunkName: "components/content/ContactUs" */),
  vDivider: () => import('~/components/content/Divider' /* webpackChunkName: "components/content/Divider" */),
  vGallery: () => import('~/components/content/Gallery' /* webpackChunkName: "components/content/Gallery" */),
  vGrid: () => import('~/components/content/Grid' /* webpackChunkName: "components/content/Grid" */),
  vHeading: () => import('~/components/content/Heading' /* webpackChunkName: "components/content/Heading" */),
  vHome: () => import('~/components/content/Home' /* webpackChunkName: "components/content/Home" */),
  vHtml: () => import('~/components/content/Html' /* webpackChunkName: "components/content/Html" */),
  vImage: () => import('~/components/content/Image' /* webpackChunkName: "components/content/Image" */),
  vSection: () => import('~/components/content/Section' /* webpackChunkName: "components/content/Section" */),
  vText: () => import('~/components/content/Text' /* webpackChunkName: "components/content/Text" */),
  vTimelines: () => import('~/components/content/Timelines' /* webpackChunkName: "components/content/Timelines" */),
  vVuetifyComponents: () =>
    import('~/components/content/VuetifyComponents' /* webpackChunkName: "components/content/VuetifyComponents" */),
}

export default {
  components,

  props: {
    layout: {
      type: Array,
      default: () => [],
    },

    content: {
      type: String,
      default: '',
    },
  },

  computed: {
    components() {
      return this.layout.map(entry => {
        const { component: name } = entry
        const component = `v-${name}`

        return { ...entry, component }
      })
    },
  },
}
</script>
